<template>
  <div class="weather-detail">
    <div v-if="weatherData">
      <h1 class="text-center">{{weatherData.title}} Weather</h1>
      <div class="list">
        <weather v-for="(cw, i) in cwList" :key="cw.id" 
          :class="[i === 0 ? 'is-active': '']"
          :title="title(cw.applicable_date)"
          :icon="cw.weather_state_abbr" 
          :minTemp="cw.min_temp"
          :maxTemp="cw.max_temp"
          :temprature="cw.the_temp" />
      </div>
    </div>
    <div v-else class="loader"></div>
  </div>
</template>
<script>
import { mapActions } from "vuex";
import Weather from '@/components/Weather.vue'

export default {
  data () {
    return {
      weatherData: null,
      weekDays: ['Sunday','Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday']
    }
  },
  components: {
    Weather
  },
  computed: {
    woeid() {
      return this.$route.params.woeid;
    },
    cwList () {
      if (!this.weatherData) return
      return this.weatherData.consolidated_weather
    }
  },
  methods: {
    ...mapActions("weather", ["getById"]),
    title (date) {
      const day = new Date(date).getDay()
      return this.weekDays[day]
    },
    async fetchDetail () {
      try {
        this.weatherData = await this.getById(this.woeid)
      } catch (err) {
        console.log(err)
      }
    }
  },
  mounted () {
    this.fetchDetail()
  }
};
</script>

<style scoped>
.weather-detail{
  display: flex;
  flex-direction: row;
  justify-content: center;
}
/deep/ .weather-card {
  margin: 0 .75rem .75rem 0;
}
</style>
